#!/usr/bin/php -q
<?php
// vim: set noexpandtab tabstop=2 softtabstop=2 shiftwidth=2:

// Updated: Xymph <tm@gamers.org>
require_once('GbxRemote.inc.php');
require_once('rpcutils.inc.php');

function showIt($key, $val, $recurs = false) {
	if (is_array($val)) {
		echo '<ul><li><b>' . $key . '</b><br/>';
		foreach ($val as $key2 => $val2) {
			showIt($key2, $val2, true);
		}
		echo "</li></ul>\n";
	} else {
		if ($recurs)
			echo '<font color="0x113355">' . $key . ' = ' . $val . "</font><br/>\n";
		else
			echo '<b>' . $key . '</b> = <font color="0x113355">' . $val . "</font><br/>\n";
	}
}

function showItFull($key) {
	global $client;
	$method = $key;
	if ($client->query($method)) {
		$res = $client->getResponse();
		showIt($method, $res);
	} else {
		echo 'Cannot get '.$method.' !  Error '.$client->getErrorCode().': '.$client->getErrorMessage()."<br/>\n";
	}
}

function showItFull50($key) {
	global $client;
	$method = $key;
	if ($client->query($method, 50, 0)) {
		$res = $client->getResponse();
		showIt($method, $res);
		return $res;
	} else {
		echo 'Cannot get '.$method.' !  Error '.$client->getErrorCode().': '.$client->getErrorMessage()."<br/>\n";
		return null;
	}
}

$client = connectServer();
if (!$client->query('system.listMethods'))
	clientError($client, 'Cannot list methods');
$methods = $client->getResponse();

header('Content-Type: text/html; charset=utf-8');

echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n";
echo "<html xmlns=\"http://www.w3.org/1999/xhtml\">\n<head>\n";
echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\n";
echo "<title>Dedicated server information</title>\n";
echo "</head>\n<body>\n";

showItFull('GetVersion');

if (in_array('GetSystemInfo', $methods))
	showItFull('GetSystemInfo');

showItFull('GetStatus');

if (in_array('GetServerPackMask', $methods))
	showItFull('GetServerPackMask');

if (in_array('GetServerPlanets', $methods))
	showItFull('GetServerPlanets');
elseif (in_array('GetServerCoppers', $methods))
	showItFull('GetServerCoppers');

showItFull('GetServerOptions');

showItFull('GetGameInfos');

if (in_array('GetCurrentMapInfo', $methods))
	showItFull('GetCurrentMapInfo');
elseif (in_array('GetCurrentChallengeInfo', $methods))
	showItFull('GetCurrentChallengeInfo');

if (in_array('GetNextMapInfo', $methods))
	showItFull('GetNextMapInfo');
elseif (in_array('GetNextChallengeInfo', $methods))
	showItFull('GetNextChallengeInfo');

showItFull50('GetCurrentRanking');

$players = showItFull50('GetPlayerList');

foreach ($players as $player) {
	$method = 'GetPlayerInfo';
	if ($client->query($method, $player['Login'])) {
		$res = $client->getResponse();
		showIt($method.':'.$player['Login'], $res);
	} else {
		echo '* Cannot get '.$method.' !  Error '.$client->getErrorCode().': '.$client->getErrorMessage()."<br/>\n";
	}
}

showItFull('GetNetworkStats');

showItFull50('GetGuestList');

if (in_array('GetIgnoreList', $methods))
	showItFull50('GetIgnoreList');

showItFull50('GetBanList');

showItFull50('GetBlackList');

showItFull('GetVehicleNetQuality');

if (in_array('GetBaseDirectory', $methods))
	showItFull('GetBaseDirectory');

showItFull('GameDataDirectory');

if (in_array('GetMapsDirectory', $methods))
	showItFull('GetMapsDirectory');
elseif (in_array('GetTracksDirectory', $methods))
	showItFull('GetTracksDirectory');

showItFull('GetSkinsDirectory');

showItFull('GetLastConnectionErrorMessage');

echo "<h2>Available methods:</h2>\n";

echo "<ul>\n";
foreach ($methods as $m) {
	echo '<li><b>' . $m . "</b><br/>\n";
	if ($client->query('system.methodSignature', $m)) {
		$signatures = $client->getResponse();
	} else {
		$signatures = array();
		echo "<font color=\"red\">{error in signature}</font><br/>\n";
	}
	if ($client->query('system.methodHelp', $m)) {
		$help = $client->getResponse();
	} else {
		$help = "<font color=\"red\">{no help}</font>";
	}

	foreach ($signatures as $sig) {
		$is_retval = 1;
		$is_firstarg = 1;
		foreach ($sig as $argtype) {
			if ($is_retval) {
				echo $argtype . ' ' . $m . '(';
				$is_retval = 0;
			} else {
				if (!$is_firstarg) {
					echo ', ';
				}
				echo $argtype;
				$is_firstarg = 0;
			}
		}
		echo ")<br/>\n";
	}
	echo '<font color="0x113355">';
	echo $help;
	echo "</font></li>\n";
}
echo "</ul>\n";

$client->Terminate();

echo "</body>\n</html>\n";
flush();
?>
