#!/usr/bin/php -q
<?php
// vim: set noexpandtab tabstop=2 softtabstop=2 shiftwidth=2:

// Updated: Xymph <tm@gamers.org>
require_once('GbxRemote.inc.php');
require_once('rpcutils.inc.php');

function showIt($key, $val, $indent) {
	if (is_array($val)) {
		echo $indent.'*'.$key." :\n";
		foreach ($val as $key2 => $val2) {
			showIt($key2, $val2, '  '.$indent);
		}
	} else {
		echo $indent.$key.' = '.$val."\n";
	}
}

function typedArg($arg) {
	if (strcasecmp($arg, 'true') == 0)
		$targ = true;
	elseif (strcasecmp($arg, 'false') == 0)
		$targ = false;
	elseif (is_numeric($arg)) {
		if (strpos($arg, '.') !== false)
			$targ = doubleval($arg);
		else
			$targ = intval($arg);
	} else
		$targ = $arg;
	return $targ;
}

// $argc : 1 + number of script args
// $argv : [0] is the scriptname

$client = connectServer();
$done = false;

// methods w/o args
if ($argc == 2) {
	$method = $argv[1];
	if ($client->query($method)) {
		$res = $client->getResponse();
		showIt($method, $res, '');
		$done = true;
	}

// methods w/ array of args
} elseif ($argc > 3 && $argv[2] == 'array') {
	$method = $argv[1];
	echo "array...\n";
	$args = array();
	for ($i = 3; $i < $argc; $i++) {
		$args[] = typedArg($argv[$i]);
	}
	foreach ($args as $argsh) {
		echo '+>'.$argsh."\n";
	}

	switch (count($args)) {
	case 1: $res = $client->query($method, $args[0]);
		break;
	case 2: $res = $client->query($method, $args[0], $args[1]);
		break;
	case 3: $res = $client->query($method, $args[0], $args[1], $args[2]);
		break;
	case 4: $res = $client->query($method, $args[0], $args[1], $args[2], $args[3]);
		break;
	case 5: $res = $client->query($method, $args[0], $args[1], $args[2], $args[3], $args[4]);
		break;
	case 6: $res = $client->query($method, $args[0], $args[1], $args[2], $args[3], $args[4], $args[5]);
		break;
	case 7: $res = $client->query($method, $args[0], $args[1], $args[2], $args[3], $args[4], $args[5], $args[6]);
		break;
	case 8: $res = $client->query($method, $args[0], $args[1], $args[2], $args[3], $args[4], $args[5], $args[6], $args[7]);
		break;
	case 9: $res = $client->query($method, $args[0], $args[1], $args[2], $args[3], $args[4], $args[5], $args[6], $args[7], $args[8]);
		break;
	}
	if ($res) {
		$res = $client->getResponse();
		showIt($method, $res, '');
		$done = true;
	}

// methods w/ 1-2 args
} elseif ($argc == 3 || $argc == 4) {
	$method = $argv[1];

	$arg2 = typedArg($argv[2]);
	if ($argc == 3) {
		$res = $client->query($method, $arg2);
	} else { // == 4
		$arg3 = typedArg($argv[3]);
		$res = $client->query($method, $arg2, $arg3);
	}
	if ($res) {
		$res = $client->getResponse();
		showIt($method, $res, '');
		$done = true;
	}

} else {
	echo '  Nothing to do! ('.$argc.")\n";
	echo '  Usage: php '.$argv[0]." xmlrpc_method args\n";
	echo '         php '.$argv[0]." xmlrpc_method array array_args\n";
	$done = true;
}

if (!$done)
	clientError($client, 'Cannot run '.$method);

$client->Terminate();
?>
